Description

Add debug logs to identify identify issues like batch rows or slow queries get stuck in 'inprog' status by providing visibility into each
processing step.

Associated revisions

Revision 01bfaa03 - 30/06/2025 12:29 PM - Sachin Divekar
Add logging to debug stuck batch and slow query jobs #28277

Revision 67806b4a - 05/07/2025 04:29 PM - Sachin Divekar

Add panic recovery with circuit breaker pattern to prevent stuck batches #28277
Add panic recovery to JobManager to prevent database transactions from being left open and rows permanently locked when panics occur.
Implementation:

e Add circuit breaker pattern in Run()/RunWithContext()
o Tolerates up to 2 consecutive panics (transient issues)
o Exits on 3rd consecutive panic (systemic issues)
o Resets counter on successful iterations
¢ Add transaction cleanup defer immediately after Begin()
o Ensures rollback even if panic occurs
o Prevents connection leaks and row locks
¢ Add panic recovery in processRow()
o Isolates failures to individual rows
o Converts panics to errors for proper status updates

This would prevent the "stuck inprog" issue where batches could never be reprocessed after a panic left them in an inconsistent state.
Revision 6f60b786 - 05/07/2025 05:12 PM - Sachin Divekar
Optimize batch status updates with bulk operations #28277

® Replace individual status update queries with bulk operations using UpdateBatchesStatusBulk and UpdateBatchRowsStatusBulk
¢ Reduce database round trips from 2N queries to 2 queries for N rows

Revision b39d8c3b - 11/07/2025 02:28 PM - Sachin Divekar
Fix race condition in JobManager #28277
Previously, JobManager used a global mutex to protect instance-specific maps (initfuncs and initblocks), which caused two issues:

1. Race condition: closelnitBlocks() accessed jm.initblocks without mutex protection
2. Unnecessary contention: Multiple JobManager instances competed for the same global lock

Revision 3ad7e2cc - 11/07/2025 02:47 PM - Sachin Divekar
Add more debug logs and some metrics #28277

Revision 199bd64b - 12/07/2025 10:56 AM - Sachin Divekar
Add configurable polling interval to JobManager #28277

Add PollinglntervalSec configuration option to JobManager to control how frequently it polls for new jobs.

History
#1 - 30/06/2025 12:28 PM - Sachin Divekar

- Status changed from New to In Progress

#2 - 30/06/2025 06:21 PM - Sachin Divekar
- % Done changed from 0 to 100

- Status changed from In Progress to Closed

Tested by running examples.
